/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * child_xwin.h
 * ------------
 *
 * Architecture-specific child functions
 */

#ifndef __impulse_rows_child_xwin_h
#define __impulse_rows_child_xwin_h

#include <impulse/rows/child.h>

#include <X11/Xlib.h>

/*                            ======--------======                           */

typedef impulse_bool (*ROWS_X_child_event_func)(XEvent *,
						ROWS_child);

typedef struct _p_ROWS_X_child_events 
{
  ROWS_X_child_event_func funcs[LASTEvent];
} *_p_ROWS_X_child_events;


typedef struct _p_ROWS_X_child_data {
  Window window;
  Window parent;
  Display *display;
  
  impulse_int mask;
  impulse_int nevents;
  _p_ROWS_X_child_events *events;
} _p_ROWS_X_child_data;

/*                            ======--------======                           */

extern Window ROWS_X_child_get_window(ROWS_child child);
extern void   ROWS_X_child_set_window(ROWS_child child,
				      Window     win);

extern void ROWS_X_child_register_events(ROWS_child child,
					 _p_ROWS_X_child_events events,
					 impulse_int mask);


#endif
