/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the ROWS widget library
 * for Impulse.
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter. Portions created by Andrew Hunter
 * are Copyright (C) 1999 Andrew Hunter.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * comms_int.h
 * -----------
 *
 * ROWS generic communication interface
 */

#ifndef __impulse_rows_comms_int_h
#define __impulse_rows_comms_int_h

#include <impulse/rows/comms.h>
#include <impulse/comms/transport_int.h>


void *ROWS_comms_create(void);
void ROWS_comms_destroy(void *data);

/* Event functions */
impulse_int ROWS_comms_handle(void *data,
			      impulse_transport_handler func,
			      void *edata);
impulse_int ROWS_comms_unhandle(void *data);


/* Connection functions */
impulse_int ROWS_comms_open(void *data,
			    impulse_unistring local,
			    impulse_unistring remote,
			    impulse_int incoming);
impulse_int ROWS_comms_accept(void *data,
			      void **client);
impulse_int ROWS_comms_close(void *data);
impulse_int ROWS_comms_active(void *data);

/* Data transfer functions */
impulse_int ROWS_comms_pending(void *data);
impulse_int ROWS_comms_send(void *data,
			    impulse_byte *buffer,
			    impulse_uint size,
			    impulse_unistring address);
impulse_int ROWS_comms_receive(void *data,
			       impulse_byte *buffer,
			       impulse_uint size,
			       impulse_unistring *address);
impulse_int ROWS_comms_peek(void *data,
			    impulse_byte *buffer,
			    impulse_uint size,
			    impulse_unistring *address);

/* Address functions */
impulse_int ROWS_comms_local(void *data,
			     impulse_unistring *address);
impulse_int ROWS_comms_remote(void *data,
			      impulse_unistring *address);


#endif
