/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * container.h
 * -----------
 *
 * Something that contains a child
 */

#ifndef __impulse_rows_container_h
#define __impulse_rows_container_h

//#include <impulse/rows/child.h>

/*                            ======--------======                           */

/* Container widget type */

typedef void **ROWS_container;

#include <impulse/rows/child.h>
/* Contained widget type */

/*                            ======--------======                           */


/*                            ======--------======                           */

/* Standard widget functions */

extern ROWS_widget            ROWS_container_create         (ROWS_drawable drawable);
extern ROWS_widget           *ROWS_container_initialise     (int id,
							     ROWS_drawable drawable);
extern impulse_inline int             ROWS_container_next_identifier(void);
extern impulse_inline ROWS_container  ROWS_container_cast           (void **widget);

/*                            ======--------======                           */


extern ROWS_child ROWS_container_child_at(ROWS_container container,
					  ROWS_point *loc);

#endif

