/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * screen_int.h
 * ------------
 *
 * Drawable implementation for screens
 */

#ifndef __impulse_rows_screen_int_h
#define __impulse_rows_screen_int_h

#include <impulse/rows/screen.h>
#include <impulse/rows/drawable_int.h>

/*                            ======--------======                           */

extern int  screen_ID;
extern int  screen_type;

void ROWS_screen_setup_int(ROWS_widget *widget,
			   ROWS_child child);

/*                            ======--------======                           */

extern void ROWS_screen_clear_area (ROWS_drawable_fparam *param);
extern void ROWS_screen_sync       (ROWS_drawable_fparam *param);
extern void ROWS_screen_draw_bitmap(ROWS_drawable_fparam *param);

extern void ROWS_screen_clip_push         (ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_pop          (ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_clear (ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_union (ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_intersect(ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_subtract(ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_set   (ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_bounds(ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_move  (ROWS_drawable_fparam *param);
extern void ROWS_screen_clip_copy  (ROWS_drawable_fparam *param);

/* Brush X functions */

extern void ROWS_screen_brush_create (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_destroy(ROWS_drawable_fparam *param);

extern void ROWS_screen_brush_use_private_gc(ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_set_gc        (ROWS_drawable_fparam *param);

/* Brush state functions */

extern void ROWS_screen_brush_set_linewidth(ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_get_fgpixel  (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_set_fgcolour (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_set_bgcolour (ROWS_drawable_fparam *param);

/* Draw with this brush */

extern void ROWS_screen_brush_draw_point    (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_draw_line     (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_draw_rectangle(ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_draw_arc      (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_fill_rectangle(ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_fill_arc      (ROWS_drawable_fparam *param);

extern void ROWS_screen_brush_set_font      (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_set_font_size (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_font_paint    (ROWS_drawable_fparam *param);
extern void ROWS_screen_brush_font_measure  (ROWS_drawable_fparam *param);

/* Colour X functions */

extern void ROWS_screen_colour_create(ROWS_drawable_fparam *param);
extern void ROWS_screen_colour_pixel(ROWS_drawable_fparam *param);
extern void ROWS_screen_colour_discard(ROWS_drawable_fparam *param);


#endif
